/*
 * MosP - Mind Open Source Project    http://www.mosp.jp/
 * Copyright (C) MIND Co., Ltd.       http://www.e-mind.co.jp/
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */
package jp.mosp.kintai.payroll.dao;

import java.sql.SQLException;
import java.util.ArrayList;
import java.util.List;

import jp.mosp.common.common.BaseDao;
import jp.mosp.common.common.MospException;
import jp.mosp.kintai.payroll.dto.MKintaiDto;

/**
 * M_KINTAI(勤怠集計)のDAOクラス 。
 */
public class MKintaiDao extends BaseDao {
	
	// テーブル名及びキー列名
	/**
	 * M_KINTAI(勤怠集計)。
	 */
	public static final String	TABLE				= "M_KINTAI";
	
	/**
	 * KEY_1 = KCODE(社員コード)。
	 */
	public static final String	KEY_1				= "KCODE";
	/**
	 * KEY_2 = SIKYUYM(支給年月)。
	 */
	public static final String	KEY_2				= "SIKYUYM";
	
	// 列名
	/**
	 * KCODE(社員コード)。
	 */
	public static final String	COL_KCODE			= "KCODE";
	/**
	 * SIKYUYM(支給年月)。
	 */
	public static final String	COL_SIKYUYM			= "SIKYUYM";
	/**
	 * SNEN(支給年)。
	 */
	public static final String	COL_SNEN			= "SNEN";
	/**
	 * STUKI(支給月)。
	 */
	public static final String	COL_STUKI			= "STUKI";
	/**
	 * SHI(支給日)。
	 */
	public static final String	COL_SHI				= "SHI";
	/**
	 * SNISSU(出勤日数)。
	 */
	public static final String	COL_SNISSU			= "SNISSU";
	/**
	 * SKAISU(出勤回数)。
	 */
	public static final String	COL_SKAISU			= "SKAISU";
	/**
	 * KINMUJI(勤務時間)。
	 */
	public static final String	COL_KINMUJI			= "KINMUJI";
	/**
	 * KYUKEIJI(休憩時間)。
	 */
	public static final String	COL_KYUKEIJI		= "KYUKEIJI";
	/**
	 * YUKYU(有給)。
	 */
	public static final String	COL_YUKYU			= "YUKYU";
	/**
	 * TOKUKYU(特別休暇)。
	 */
	public static final String	COL_TOKUKYU			= "TOKUKYU";
	/**
	 * KEKKIN(一般欠勤日数)。
	 */
	public static final String	COL_KEKKIN			= "KEKKIN";
	/**
	 * SKEKKIN(傷病欠勤日数)。
	 */
	public static final String	COL_SKEKKIN			= "SKEKKIN";
	/**
	 * DAIKYU(代替休暇)。
	 */
	public static final String	COL_DAIKYU			= "DAIKYU";
	/**
	 * FURIKAE(振替休暇)。
	 */
	public static final String	COL_FURIKAE			= "FURIKAE";
	/**
	 * SONOTA(その他休暇)。
	 */
	public static final String	COL_SONOTA			= "SONOTA";
	/**
	 * TISOKAI(遅刻早退回数)。
	 */
	public static final String	COL_TISOKAI			= "TISOKAI";
	/**
	 * TIJIKAN(遅刻早退時間)。
	 */
	public static final String	COL_TIJIKAN			= "TIJIKAN";
	/**
	 * ZAJIKAN(普通残業時間)。
	 */
	public static final String	COL_ZAJIKAN			= "ZAJIKAN";
	/**
	 * KSJIKAN(休日出勤時間)。
	 */
	public static final String	COL_KSJIKAN			= "KSJIKAN";
	/**
	 * SNJIKAN(深夜勤務時間)。
	 */
	public static final String	COL_SNJIKAN			= "SNJIKAN";
	/**
	 * KAIKIN(精皆勤手当支給)。
	 */
	public static final String	COL_KAIKIN			= "KAIKIN";
	/**
	 * SYOKUJIKAISU(食事手当支給回数)。
	 */
	public static final String	COL_SYOKUJIKAISU	= "SYOKUJIKAISU";
	/**
	 * CYOKUKAISU1(1直手当支給回数)。
	 */
	public static final String	COL_CYOKUKAISU1		= "CYOKUKAISU1";
	/**
	 * CYOKUKAISU2(2直手当支給回数)。
	 */
	public static final String	COL_CYOKUKAISU2		= "CYOKUKAISU2";
	/**
	 * CYOKUKAISU3(3直手当支給回数)。
	 */
	public static final String	COL_CYOKUKAISU3		= "CYOKUKAISU3";
	/**
	 * HOKAKAISU1(その他支給回数1)。
	 */
	public static final String	COL_HOKAKAISU1		= "HOKAKAISU1";
	/**
	 * HOKAKAISU2(その他支給回数2)。
	 */
	public static final String	COL_HOKAKAISU2		= "HOKAKAISU2";
	/**
	 * HOKAKAISU3(その他支給回数3)。
	 */
	public static final String	COL_HOKAKAISU3		= "HOKAKAISU3";
	/**
	 * HOKAKAISU4(その他支給回数4)。
	 */
	public static final String	COL_HOKAKAISU4		= "HOKAKAISU4";
	/**
	 * HOKAKAISU5(その他支給回数5)。
	 */
	public static final String	COL_HOKAKAISU5		= "HOKAKAISU5";
	/**
	 * SINSEIGAKU(支払申請額)。
	 */
	public static final String	COL_SINSEIGAKU		= "SINSEIGAKU";
	/**
	 * NIJIKYU(二時間年休)。
	 */
	public static final String	COL_NIJIKYU			= "NIJIKYU";
	/**
	 * WARIMASI1(1.00割増)。
	 */
	public static final String	COL_WARIMASI1		= "WARIMASI1";
	

	/**
	 * コンストラクタ
	 */
	public MKintaiDao() {
		super();
	}
	
	/**
	 * 検索結果取得(DTOのList)
	 * @return List 検索リスト
	 * @throws SQLException SQL例外が発生した場合
	 */
	private List<MKintaiDto> mappingAll() throws SQLException {
		List<MKintaiDto> all = new ArrayList<MKintaiDto>();
		while (rs.next()) {
			all.add(mapping());
		}
		return all;
	}
	
	/**
	 * 検索結果取得(DTO)
	 * @return m_kintaiDto m_kintaiレコード
	 * @throws SQLException SQL例外が発生した場合
	 */
	private MKintaiDto mapping() throws SQLException {
		MKintaiDto dto = new MKintaiDto();
		dto.setKCode(rs.getString(COL_KCODE));
		dto.setSikyuYM(rs.getString(COL_SIKYUYM));
		dto.setSNen(rs.getInt(COL_SNEN));
		dto.setSTuki(rs.getInt(COL_STUKI));
		dto.setSHi(rs.getInt(COL_SHI));
		dto.setSNissu(rs.getDouble(COL_SNISSU));
		dto.setSKaisu(rs.getInt(COL_SKAISU));
		dto.setKinmuJi(rs.getInt(COL_KINMUJI));
		dto.setKyukeiJi(rs.getInt(COL_KYUKEIJI));
		dto.setYukyu(rs.getDouble(COL_YUKYU));
		dto.setTokuKyu(rs.getDouble(COL_TOKUKYU));
		dto.setKekkin(rs.getDouble(COL_KEKKIN));
		dto.setSKekkin(rs.getDouble(COL_SKEKKIN));
		dto.setDaiKyu(rs.getDouble(COL_DAIKYU));
		dto.setFurikae(rs.getDouble(COL_FURIKAE));
		dto.setSonota(rs.getInt(COL_SONOTA));
		dto.setTiSoKai(rs.getInt(COL_TISOKAI));
		dto.setTiJikan(rs.getInt(COL_TIJIKAN));
		dto.setZaJikan(rs.getInt(COL_ZAJIKAN));
		dto.setKsJikan(rs.getInt(COL_KSJIKAN));
		dto.setSnJikan(rs.getInt(COL_SNJIKAN));
		dto.setKaikin(rs.getInt(COL_KAIKIN));
		dto.setSyokujiKaisu(rs.getInt(COL_SYOKUJIKAISU));
		dto.setCyokuKaisu1(rs.getInt(COL_CYOKUKAISU1));
		dto.setCyokuKaisu2(rs.getInt(COL_CYOKUKAISU2));
		dto.setCyokuKaisu3(rs.getInt(COL_CYOKUKAISU3));
		dto.setHokaKaisu1(rs.getInt(COL_HOKAKAISU1));
		dto.setHokaKaisu2(rs.getInt(COL_HOKAKAISU2));
		dto.setHokaKaisu3(rs.getInt(COL_HOKAKAISU3));
		dto.setHokaKaisu4(rs.getInt(COL_HOKAKAISU4));
		dto.setHokaKaisu5(rs.getInt(COL_HOKAKAISU5));
		dto.setSinseiGaku(rs.getInt(COL_SINSEIGAKU));
		dto.setNijiKyu(rs.getInt(COL_NIJIKYU));
		dto.setWarimasi1(rs.getInt(COL_WARIMASI1));
		mappingCommonInfo(dto);
		return dto;
	}
	
	/**
	 * 全データ取得
	 * @return List 検索結果(DTOのList)
	 * @throws SQLException SQL例外が発生した場合
	 * @throws IllegalAccessException	メソッドにアクセスできない場合
	 * @throws NoSuchFieldException	フィールドが見つからなかった場合
	 */
	public List<MKintaiDto> findAll() throws SQLException, IllegalAccessException, NoSuchFieldException {
		try {
			prepareStatement(getSelectQuery(getClass()) + getOrderForKey(getClass()));
			executeQuery();
			List<MKintaiDto> all = mappingAll();
			return all;
		} catch (SQLException e) {
			throw e;
		} finally {
			releaseResultSet();
			releasePreparedStatement();
		}
	}
	
	/**
	 * キーによるデータ取得
	 * @param kcode 社員コード(検索キー)
	 * @param sikyuym 支給年月(検索キー)
	 * @return dto 検索結果(DTO)
	 * @throws SQLException SQL例外が発生した場合
	 * @throws IllegalAccessException	メソッドにアクセスできない場合
	 * @throws NoSuchFieldException	フィールドが見つからなかった場合
	 */
	public MKintaiDto findForKey(String kcode, String sikyuym) throws SQLException, IllegalAccessException,
			NoSuchFieldException {
		try {
			index = 1;
			prepareStatement(getSelectQuery(getClass()) + getConditionForKey(getClass()));
			setParam(index++, kcode);
			setParam(index++, sikyuym);
			executeQuery();
			MKintaiDto dto = null;
			if (rs.next()) {
				dto = mapping();
				mappingCommonInfo(dto);
			}
			return dto;
		} catch (SQLException e) {
			throw e;
		} finally {
			releaseResultSet();
			releasePreparedStatement();
		}
	}
	
	/**
	 * キーによる行ロック取得
	 * @param kcode 社員コード(検索キー)
	 * @param sikyuym 支給年月(検索キー)
	 * @return dto 検索結果(DTO)
	 * @throws SQLException SQL例外が発生した場合
	 * @throws IllegalAccessException	メソッドにアクセスできない場合
	 * @throws NoSuchFieldException	フィールドが見つからなかった場合
	 */
	public MKintaiDto findForUpdate(String kcode, String sikyuym) throws SQLException, IllegalAccessException,
			NoSuchFieldException {
		try {
			index = 1;
			prepareStatement(getSelectQuery(getClass()) + getConditionForKey(getClass()) + getForUpdate());
			setParam(index++, kcode);
			setParam(index++, sikyuym);
			executeQuery();
			MKintaiDto dto = null;
			if (rs.next()) {
				dto = mapping();
				mappingCommonInfo(dto);
			}
			return dto;
		} catch (SQLException e) {
			throw e;
		} finally {
			releaseResultSet();
			releasePreparedStatement();
		}
	}
	
	/**
	 * キーによる行ロック取得
	 * @param sikyuym 支給年月(検索キー)
	 * @throws SQLException SQL例外が発生した場合
	 * @throws IllegalAccessException	メソッドにアクセスできない場合
	 * @throws NoSuchFieldException	フィールドが見つからなかった場合
	 */
	public void findForUpdate(String sikyuym) throws SQLException, IllegalAccessException, NoSuchFieldException {
		try {
			index = 1;
			StringBuffer sb = new StringBuffer();
			sb.append("WHERE ");
			sb.append(COL_SIKYUYM);
			sb.append(" = ? ");
			prepareStatement(getSelectQuery(getClass()) + sb.toString() + getForUpdate());
			setParam(index++, sikyuym);
			executeQuery();
		} catch (SQLException e) {
			throw e;
		} finally {
			releaseResultSet();
			releasePreparedStatement();
		}
	}
	
	/**
	 * 条件文によるデータ取得
	 * @param kcode 検索社員コード
	 * @param sikyuym 検索支給年月
	 * @return List 検索結果(DTOのList)
	 * @throws SQLException SQL例外が発生した場合
	 * @throws IllegalAccessException	メソッドにアクセスできない場合
	 * @throws NoSuchFieldException	フィールドが見つからなかった場合
	 */
	public List<?> findForCondition(String kcode, String sikyuym) throws SQLException, IllegalAccessException,
			NoSuchFieldException {
		index = 1;
		StringBuffer sb = new StringBuffer();
		sb.append("WHERE ");
		sb.append(COL_KCODE);
		sb.append(" LIKE ? AND ");
		sb.append(COL_SIKYUYM);
		sb.append(" LIKE ? ");
		try {
			prepareStatement(getSelectQuery(getClass()) + sb.toString() + getOrderForKey(getClass()));
			setParam(index++, kcode);
			setParam(index++, sikyuym + "%");
			executeQuery();
			List<?> list = mappingAll();
			return list;
		} catch (SQLException e) {
			throw e;
		} finally {
			releaseResultSet();
			releasePreparedStatement();
		}
	}
	
	/**
	 * 条件文によるデータ取得(範囲指定)
	 * @param kcode 検索社員コード
	 * @param startSikyuNen 検索開始年
	 * @param startSikyuTuki 検索終了年
	 * @param endSikyuNen 検索開始月
	 * @param endSikyuTuki 検索終了月
	 * @param dif 差分年
	 * @return List 検索結果(DTOのList)
	 * @throws SQLException SQL例外が発生した場合
	 * @throws IllegalAccessException	メソッドにアクセスできない場合
	 * @throws NoSuchFieldException	フィールドが見つからなかった場合
	 */
	public List<MKintaiDto> findForCondition(String kcode, int startSikyuNen, int startSikyuTuki, int endSikyuNen,
			int endSikyuTuki, int dif) throws SQLException, IllegalAccessException, NoSuchFieldException {
		index = 1;
		StringBuffer sb = new StringBuffer();
		sb.append("WHERE ");
		sb.append(COL_KCODE);
		sb.append(" = ? AND ");
		if (dif != 0) {
			sb.append("((");
			sb.append(COL_SNEN);
			sb.append(" = ? AND ");
			sb.append(COL_STUKI);
			sb.append(" BETWEEN");
			sb.append(" ? AND ? )");
			sb.append(" OR ");
		}
		for (int i = 1; dif > i; i++) {
			sb.append(COL_SNEN);
			sb.append(" = ?");
			sb.append(" OR ");
		}
		sb.append("(");
		sb.append(COL_SNEN);
		sb.append(" = ? AND ");
		sb.append(COL_STUKI);
		sb.append(" BETWEEN");
		sb.append(" ? AND ? )");
		if (dif != 0) {
			sb.append(")");
		}
		try {
			prepareStatement(getSelectQuery(getClass()) + sb.toString() + getOrderForKey(getClass()));
			setParam(index++, kcode);
			if (dif != 0) {
				setParam(index++, startSikyuNen);
				setParam(index++, startSikyuTuki);
				setParam(index++, 12);
			}
			for (int i = 1; dif > i; i++) {
				setParam(index++, startSikyuNen + i);
			}
			setParam(index++, endSikyuNen);
			if (dif == 0) {
				setParam(index++, startSikyuTuki);
			} else {
				setParam(index++, 1);
			}
			setParam(index++, endSikyuTuki);
			executeQuery();
			List<MKintaiDto> list = mappingAll();
			return list;
		} catch (SQLException e) {
			throw e;
		} finally {
			releaseResultSet();
			releasePreparedStatement();
		}
	}
	
	/**
	 * 条件文によるデータ取得
	 * @param sikyuym 検索支給年月
	 * @return List 検索結果(DTOのList)
	 * @throws SQLException SQL例外が発生した場合
	 * @throws IllegalAccessException	メソッドにアクセスできない場合
	 * @throws NoSuchFieldException	フィールドが見つからなかった場合
	 */
	public List<MKintaiDto> findForExport(String sikyuym) throws SQLException, IllegalAccessException,
			NoSuchFieldException {
		index = 1;
		StringBuffer sb = new StringBuffer();
		sb.append("WHERE ");
		sb.append(COL_SIKYUYM);
		sb.append(" = ? ");
		try {
			prepareStatement(getSelectQuery(getClass()) + sb.toString() + getOrderForKey(getClass()));
			setParam(index++, sikyuym);
			executeQuery();
			List<MKintaiDto> list = mappingAll();
			return list;
		} catch (SQLException e) {
			throw e;
		} finally {
			releaseResultSet();
			releasePreparedStatement();
		}
	}
	
	/**
	 * データ挿入
	 * @param dto 挿入対象DTO
	 * @return int 挿入結果(件数)
	 * @throws SQLException SQL例外が発生した場合
	 * @throws IllegalAccessException	メソッドにアクセスできない場合
	 * @throws NoSuchFieldException	フィールドが見つからなかった場合
	 * @throws MospException 	MosP例外処理が発生した場合
	 */
	public int insert(MKintaiDto dto) throws SQLException, IllegalAccessException, NoSuchFieldException, MospException {
		try {
			index = 1;
			prepareStatement(getInsertQuery(getClass()));
			setParams(dto, true);
			executeUpdate();
			chkInsert(1);
			return cnt;
		} catch (SQLException e) {
			throw e;
		} finally {
			releaseResultSet();
			releasePreparedStatement();
		}
	}
	
	/**
	 * @param list		旧勤怠情報
	 * @param divSize	件数
	 * @return	挿入結果(件数)
	 * @throws SQLException SQL例外が発生した場合
	 * @throws IllegalAccessException	メソッドにアクセスできない場合
	 * @throws NoSuchFieldException	フィールドが見つからなかった場合
	 * @throws MospException 	MosP例外処理が発生した場合
	 */
	public int insert(List<MKintaiDto> list, int divSize) throws SQLException, IllegalAccessException,
			NoSuchFieldException, MospException {
		try {
			index = 1;
			int listSize = list.size();
			int rev = listSize / divSize + 1;
			if (listSize % divSize == 0) {
				rev--;
			}
			int insertCount = 0;
			List<MKintaiDto> divList = new ArrayList<MKintaiDto>();
			for (int i = 0; i < rev; i++) {
				// リストをdiv件ごと分割する。
				for (int k = 0; k < divSize; k++) {
					int count = k + (i * divSize);
					if (count >= listSize) {
						break;
					}
					divList.add(list.get(count));
				}
				int divListSize = divList.size();
				prepareStatement(getInsertQuery(getClass(), divListSize, divSize));
				for (MKintaiDto dto : divList) {
					setParams(dto, true);
				}
				executeUpdate();
				clearParams();
				index = 1;
				divList.clear();
				chkInsert(divListSize);
				insertCount += cnt;
			}
			return insertCount;
		} catch (SQLException e) {
			throw e;
		} finally {
			releaseResultSet();
			releasePreparedStatement();
		}
	}
	
	/**
	 * データ挿入
	 * @param 	aryDto 挿入対象DTO
	 * @return int 挿入結果(件数)
	 * @throws SQLException SQL例外が発生した場合
	 * @throws IllegalAccessException	メソッドにアクセスできない場合
	 * @throws NoSuchFieldException	フィールドが見つからなかった場合
	 * @throws MospException 	MosP例外処理が発生した場合
	 */
	public int insert(MKintaiDto[] aryDto) throws SQLException, IllegalAccessException, NoSuchFieldException,
			MospException {
		try {
			index = 1;
			prepareStatement(getInsertQuery(getClass(), aryDto.length, aryDto.length));
			for (MKintaiDto dto : aryDto) {
				setParams(dto, true);
			}
			executeUpdate();
			chkInsert(aryDto.length);
			return cnt;
		} catch (SQLException e) {
			throw e;
		} finally {
			releaseResultSet();
			releasePreparedStatement();
		}
	}
	
	/**
	 * データ更新
	 * @param dto 更新対象DTO
	 * @return int 更新結果(件数)
	 * @throws SQLException SQL例外が発生した場合
	 * @throws IllegalAccessException	メソッドにアクセスできない場合
	 * @throws NoSuchFieldException	フィールドが見つからなかった場合
	 * @throws MospException 	MosP例外処理が発生した場合
	 */
	public int update(MKintaiDto dto) throws SQLException, IllegalAccessException, NoSuchFieldException, MospException {
		try {
			index = 1;
			prepareStatement(getUpdateQuery(getClass()));
			setParams(dto, false);
			setParam(index++, dto.getKCode());
			setParam(index++, dto.getSikyuYM());
			executeUpdate();
			chkUpdate(1);
			return cnt;
		} catch (SQLException e) {
			throw e;
		} finally {
			releaseResultSet();
			releasePreparedStatement();
		}
	}
	
	/**
	 * データ削除
	 * @param dto 更新対象DTO
	 * @return int 削除結果(件数)
	 * @throws SQLException SQL例外が発生した場合
	 * @throws IllegalAccessException	メソッドにアクセスできない場合
	 * @throws NoSuchFieldException	フィールドが見つからなかった場合
	 * @throws MospException 	MosP例外処理が発生した場合
	 */
	public int delete(MKintaiDto dto) throws SQLException, IllegalAccessException, NoSuchFieldException, MospException {
		try {
			index = 1;
			prepareStatement(getDeleteQuery(getClass()));
			setParam(index++, dto.getKCode());
			setParam(index++, dto.getSikyuYM());
			executeUpdate();
			chkDelete(1);
			return cnt;
		} catch (SQLException e) {
			throw e;
		} finally {
			releaseResultSet();
			releasePreparedStatement();
		}
	}
	
	/**
	 * データ削除
	 * @param aryDto 更新対象DTO
	 * @param sikyuym 	更新対象年月
	 * @return int 削除結果(件数)
	 * @throws SQLException SQL例外が発生した場合
	 * @throws IllegalAccessException	メソッドにアクセスできない場合
	 * @throws NoSuchFieldException	フィールドが見つからなかった場合
	 * @throws MospException 	MosP例外処理が発生した場合
	 */
	public int delete(MKintaiDto[] aryDto, String sikyuym) throws SQLException, IllegalAccessException,
			NoSuchFieldException, MospException {
		try {
			index = 1;
			StringBuffer sb = new StringBuffer();
			sb.append("DELETE FROM ");
			sb.append(TABLE);
			sb.append(" WHERE (");
			int i = 0;
			while (i != aryDto.length) {
				sb.append(COL_KCODE);
				sb.append(" = ? OR ");
				i++;
			}
			sb.delete(sb.length() - 4, sb.length());
			sb.append(") AND ");
			sb.append(COL_SIKYUYM);
			sb.append(" = ?");
			prepareStatement(sb.toString());
			for (MKintaiDto dto : aryDto) {
				setParam(index++, dto.getKCode());
			}
			setParam(index++, sikyuym);
			executeUpdate();
			return cnt;
		} catch (SQLException e) {
			throw e;
		} finally {
			releaseResultSet();
			releasePreparedStatement();
		}
	}
	
	/**
	 * データ削除
	 * @param 	sikyuym	更新対象年月
	 * @return int 削除結果(件数)
	 * @throws SQLException SQL例外が発生した場合
	 * @throws IllegalAccessException	メソッドにアクセスできない場合
	 * @throws NoSuchFieldException	フィールドが見つからなかった場合
	 * @throws MospException 	MosP例外処理が発生した場合
	 */
	public int delete(String sikyuym) throws SQLException, IllegalAccessException, NoSuchFieldException, MospException {
		try {
			index = 1;
			StringBuffer sb = new StringBuffer();
			sb.append("DELETE FROM ");
			sb.append(TABLE);
			sb.append(" ");
			sb.append("WHERE ");
			sb.append(COL_SIKYUYM);
			sb.append(" = ? ");
			prepareStatement(sb.toString());
			setParam(index++, sikyuym);
			executeUpdate();
			return cnt;
		} catch (SQLException e) {
			throw e;
		} finally {
			releaseResultSet();
			releasePreparedStatement();
		}
	}
	
	/**
	 * パラメータ設定
	 * @param dto 更新対象DTO
	 * @param isInsert  挿入文フラグ(true：挿入文、false：更新文)
	 * @throws SQLException SQL例外が発生した場合
	 */
	private void setParams(MKintaiDto dto, boolean isInsert) throws SQLException {
		setParam(index++, dto.getKCode());
		setParam(index++, dto.getSikyuYM());
		setParam(index++, dto.getSNen());
		setParam(index++, dto.getSTuki());
		setParam(index++, dto.getSHi());
		setParam(index++, dto.getSNissu());
		setParam(index++, dto.getSKaisu());
		setParam(index++, dto.getKinmuJi());
		setParam(index++, dto.getKyukeiJi());
		setParam(index++, dto.getYukyu());
		setParam(index++, dto.getTokuKyu());
		setParam(index++, dto.getKekkin());
		setParam(index++, dto.getSKekkin());
		setParam(index++, dto.getDaiKyu());
		setParam(index++, dto.getFurikae());
		setParam(index++, dto.getSonota());
		setParam(index++, dto.getTiSoKai());
		setParam(index++, dto.getTiJikan());
		setParam(index++, dto.getZaJikan());
		setParam(index++, dto.getKsJikan());
		setParam(index++, dto.getSnJikan());
		setParam(index++, dto.getKaikin());
		setParam(index++, dto.getSyokujiKaisu());
		setParam(index++, dto.getCyokuKaisu1());
		setParam(index++, dto.getCyokuKaisu2());
		setParam(index++, dto.getCyokuKaisu3());
		setParam(index++, dto.getHokaKaisu1());
		setParam(index++, dto.getHokaKaisu2());
		setParam(index++, dto.getHokaKaisu3());
		setParam(index++, dto.getHokaKaisu4());
		setParam(index++, dto.getHokaKaisu5());
		setParam(index++, dto.getSinseiGaku());
		setParam(index++, dto.getNijiKyu());
		setParam(index++, dto.getWarimasi1());
		setCommonParams(isInsert);
	}
	
	/**
	 * テーブルロック
	 * @param 	sikyuYM	更新対象年月
	 * @throws SQLException SQL例外が発生した場合
	 * @throws IllegalAccessException	メソッドにアクセスできない場合
	 * @throws NoSuchFieldException	フィールドが見つからなかった場合
	 */
	public void tableLock(String sikyuYM) throws SQLException, IllegalAccessException, NoSuchFieldException {
		try {
			if (conn.getMetaData().getDatabaseProductName().equals("MySQL")) {
				// DBがMySQLの場合は行ロック
				findForUpdate(sikyuYM);
			} else {
				// DBがPostgreSQLの場合はテーブルロック
				StringBuffer sb = new StringBuffer();
				sb.append("LOCK TABLE ");
				sb.append(TABLE);
				prepareStatement(sb.toString());
				executeUpdate();
			}
		} catch (SQLException e) {
			throw e;
		} finally {
			releaseResultSet();
			releasePreparedStatement();
		}
	}
	
	/**
	 * テーブルロック
	 * @param	kCode	社員コード
	 * @param 	sikyuYM	更新対象年月
	 * @throws SQLException SQL例外が発生した場合
	 * @throws IllegalAccessException	メソッドにアクセスできない場合
	 * @throws NoSuchFieldException	フィールドが見つからなかった場合
	 */
	public void tableLock(String kCode, String sikyuYM) throws SQLException, IllegalAccessException,
			NoSuchFieldException {
		try {
			if (conn.getMetaData().getDatabaseProductName().equals("MySQL")) {
				// DBがMySQLの場合は行ロック
				findForUpdate(kCode, sikyuYM);
			} else {
				// DBがPostgreSQLの場合はテーブルロック
				StringBuffer sb = new StringBuffer();
				sb.append("LOCK TABLE ");
				sb.append(TABLE);
				prepareStatement(sb.toString());
				executeUpdate();
			}
		} catch (SQLException e) {
			throw e;
		} finally {
			releaseResultSet();
			releasePreparedStatement();
		}
	}
	
	/**
	 * テーブルロック
	 * @param	listMKintai	DTO
	 * @param 	sikyuYM		更新対象年月
	 * @throws SQLException SQL例外が発生した場合
	 * @throws IllegalAccessException	メソッドにアクセスできない場合
	 * @throws NoSuchFieldException	フィールドが見つからなかった場合
	 */
	public void tableLock(List<MKintaiDto> listMKintai, String sikyuYM) throws SQLException, IllegalAccessException,
			NoSuchFieldException {
		try {
			if (conn.getMetaData().getDatabaseProductName().equals("MySQL")) {
				// DBがMySQLの場合は行ロック
				for (MKintaiDto mKintaiDto : listMKintai) {
					MKintaiDto dto = mKintaiDto;
					findForUpdate(dto.getKCode(), sikyuYM);
				}
			} else {
				// DBがPostgreSQLの場合はテーブルロック
				StringBuffer sb = new StringBuffer();
				sb.append("LOCK TABLE ");
				sb.append(TABLE);
				prepareStatement(sb.toString());
				executeUpdate();
			}
		} catch (SQLException e) {
			throw e;
		} finally {
			releaseResultSet();
			releasePreparedStatement();
		}
	}
	
}
